local function find_opponent(player)
    local opponent

    player:field():find_characters(function(c)
        if c:team() == player:team() then
            -- already on the same team
            return false
        end

        local possible_p = Player.from(c)

        if possible_p then
            -- is a player on the opposite team!
            -- found the opponent!
            opponent = possible_p
        end

        return false
    end)

    return opponent
end

local function recruit(player)
    local opponent = find_opponent(player)

    if not opponent then
        -- no opponent
        return
    end
    local fx = Artifact.new()
    local field = player:field()
    field:spawn(fx, field:tile_at(1, 0))
    local entity_id = fx:id()
    for x = 0, 6, 1 do
        for y = 0, 3, 1 do
            field:tile_at(x, y):reserve_for_id(entity_id)
        end
    end
    field:tile_at(1, 1):set_state(TileState.Hidden)
    field:tile_at(2, 1):set_state(TileState.Hidden)
    field:tile_at(3, 1):set_state(TileState.Hidden)
    field:tile_at(4, 1):set_state(TileState.Hidden)
    field:tile_at(5, 1):set_state(TileState.Hidden)
    field:tile_at(6, 1):set_state(TileState.Hidden)
    field:tile_at(1, 3):set_state(TileState.Hidden)
    field:tile_at(2, 3):set_state(TileState.Hidden)
    field:tile_at(3, 3):set_state(TileState.Hidden)
    field:tile_at(4, 3):set_state(TileState.Hidden)
    field:tile_at(5, 3):set_state(TileState.Hidden)
    field:tile_at(6, 3):set_state(TileState.Hidden)
end

function augment_init(augment)
    local player = augment:owner()
    local component = player:create_component(Lifetimes.Local)

    local i = 0

    component.on_update_func = function()
        i = i + 1

        -- allow time for setup
        if i == 1 then return end

        recruit(player)
        Resources.play_music("music.mid")
        component:eject()
    end
end
